<template>
    <div>
        <div class="form-group">
            <input
                class="form-control"
                type="text"
                v-model="name"
                placeholder="Type a your name..."
                @keyup.enter="sendMessage"
            >
        </div>

        <div class="form-group">
            <input
                class="form-control"
                type="text"
                v-model="message"
                placeholder="Type a message..."
                @keyup.enter="sendMessage"
                :disabled="!nameFilled"
            >
        </div>

        <div class="form-group">
            <button
                @click="sendMessage"
                class="btn btn-outline-dark"
                :disabled="!nameFilled && !messageFilled"
            >send
            </button>
        </div>
    </div>
</template>
<script>
    export default {
        name: 'MessageEmitter',
        data: () => ({
            message: '',
            name: ''
        }),
        computed: {
            nameFilled () {
                return this.name.length >= 3
            },
            messageFilled () {
                return this.message.length > 3
            }
        },
        methods: {
            async sendMessage () {
                const {name, message} = this

                if (this.nameFilled && this.messageFilled) {
                    await window.axios.post('/messages', {name, message})
                    this.message = ''
                }
            }
        }
    }
</script>
